/*( -Oityb1 -Gs -W3 -Zi -link USER32.LIB /debug:full /DEBUGTYPE:COFF /MAP )*/
/*( -w -O1 )*/
/*( --pedantic -O2 )*/
/*	DOSŎgȂȂĂ */

//	mots2bin Motorola S-Record t@C .BIN t@C֕ϊ
#define __RELVER__ "Exp 0.01"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
char Version[] =
	"mots2bin "__RELVER__" " "M.Higuchi ("__DATE__")";

typedef unsigned char BYTE;

#define BUFF_SIZE ((255+2)*2+2)	// sobt@TCY

void pexit( char *format, ... );

struct
//	R}hCIvV
{
	unsigned long O_offs;	// ROMzuItZbg
	unsigned long O_size;	// ROM̃oCgTCY
	char Ign;	// Ignore check-sum
	char *Src;
	char *Dest;
}	Opt;

void usage(void)
{
	static char help[]=
{
	"mots2bin S-Record (Motorola HEX) to binary converter." __RELVER__ "\n"
	"Syntax: mots2bin [Options] [source] [destination]\n"
	"Options are ...\n"
	"-I         Ignore check-sum.\n"
	"-O=xxxxxx  Offset (hex).\n"
	"-S=xxxxxx  object Size (hex).\n"
	"-?  display this message.\n"
};
	printf("\n%s\n%s",Version,help);
	exit(0);
}


//	=================== R}hC̋ᖡ ========================
void argGetHex(const char *p,unsigned long *val)
//	R}hCIvV p ("=xxxx") xxxx(HEX) *val ɕϊ
//	ӖŝƂ usage() ֍sȂ!!
{
	int c;
	register unsigned long u=0;
	if( *(++p) != '=' )usage();
	while( (c=*(++p))!=0 )
	{
		u<<=4;
		c|=0x20;	/* tolowerĂ */
		if (c>='0' && c<='9')
			u|=(unsigned long)(c-'0');
		else if (c>='a'&&c<='f' )
			u|=(unsigned long)(c-('a'-10));
		else usage();
	}
	*val = u;
}


void getArgOption(int argc, char *argv[])
//	Opt R}hC͂ Opt 𓾂
{
	int i;
	char *p;
//	if(argc < 2) usage();
	Opt.O_offs = 0;			// offset
	Opt.O_size = 0x100000;	// bytesize = 640kB
	Opt.Ign = 0;			// no ignore check-sum
	Opt.Src = NULL;
	Opt.Dest = NULL;
	for(i=1;i<argc;i++)
	{
		p=argv[i];
		if(*p=='/' || *p=='-')
		{
			switch ( ( *(++p) ) | 0x20) /* tolower() */
			{
			case 'o':
				argGetHex(p,&Opt.O_offs );
				break;
			case 's':
				argGetHex(p,&Opt.O_size );
				break;
			case 'i':
				Opt.Ign=1;
				break;
			default:
				usage();
				break;
			}
		}
		else if (Opt.Src==NULL) Opt.Src=p; else Opt.Dest= p;
	}
}

//	=================== ROMC[W ========================

BYTE *Obj;
unsigned int ObjBegin;
unsigned int ObjLast;

//	======================= ߂肾Օ\p =============================

char * byte2Hex(register unsigned char b,register char *p)
// ޲ b  p ͷ 2ɂĂ.
{
	static char hex[]="0123456789ABCDEF";
	*p++=hex[b>>4];
	*p++=hex[b & 15];
	return p;
}

void hexDump1Line(unsigned char *mem,int len)
{
	char buff[80];
	char *p;
	int i;
	p=buff;
	for(i=0;i<len;i++)
	{
		p=byte2Hex(*mem++,p);
		*p= (i==7)? (char)'-':(char)' ';
		p++;
	}
	*p++='\n';	*p='\0';
	printf("%s",buff);
}

//	=================== ROMC[Wo ========================

void ObjDump(FILE *fpout)
{
	printf("Source: Start=0x%08X  Last=0x%08X (effective adrs)\n",
		ObjBegin+Opt.O_offs,ObjLast+Opt.O_offs);
	printf("Destination file size=0x%08X Offset=0x%08X\n",
		ObjLast+1,Opt.O_offs);
	if(fpout==stdout)
	{
		unsigned int adrs;
		unsigned int line= (ObjLast-ObjBegin)/16+1;
		for(adrs=ObjBegin;line>0;line--)
		{
			printf("%08X : ",adrs );
			hexDump1Line(&Obj[adrs],16);
			adrs+=16;
		}
	}
	else
	{
		size_t wrsize,nbytes;
		wrsize=ObjLast+1;
		nbytes =
			fwrite((void *)Obj,sizeof(unsigned char),wrsize,fpout);
		if(nbytes != wrsize)
			pexit("Failed to write output file .");
		fclose(fpout);
	}
}

//	=================== S-RECORD̋ᖡ ========================

int isXdigit(register int c)
{
	if (c>='0' && c<='9') return 1;
	c |= 0x20;
	if (c>='a'&&c<='f' ) return 1;
	return 0;
}

int hextoNib(register int c )	/* '0' ` 'F'  0x00 ` 0x0f	*/
{
	int i;
	c|=0x20;
	if (c>='0' && c<='9') i=(c-'0');
	else if (c>='a'&&c<='f' ) i = c-('a'-10);
	else i = -1;
	return i;
}

int toByte(register const char *hex)
{
	return ( hextoNib(*hex)<<4 )|hextoNib(*(hex+1)) ;
}

int calcChecksum(register const char *hex)
{
	int sum;
	for(sum=0; isXdigit(*hex) && isXdigit(*(hex+1)) ;hex+=2)
	{
		sum += toByte(hex);
	}
	sum &= 0xff;
	return sum;
}

void printHeader( char *hex)
{
	char buff[256];
	char *p=buff;
	int len;
	hex +=2;
	len=toByte( hex) - 3;
	hex +=6;
	while(len>0)
	{
		int c;
		if((c=toByte(hex))!=0) *p++=(char)c;
		len--;
		hex +=2;
	}
	*p='\0';
	printf("Header : <%s>\n",buff);
}

void printFooter( char *hex)
{
	unsigned int start;
	int adrlen;
	register char *p = hex+1;
	adrlen=11 - (int)(*p) ; p++;
	for(start=0;adrlen>0;adrlen--)
	{
		start <<= 8;
		start |= toByte( p ); p+=2;
	}
	printf("Footer: (%08Xh)\n",start);
}

#if 0
struct hexform {
	char typeC;			/* ^Cv 'S'	 */
	char typeN;			/* ^Cv 0,1,2,3,7,8 or 9	  */
	char numrec[ 2 ];	/* f[^	  */
	char record[ 4 ];	/* AhX(4,6,8),f[^,T	 */
} *phex;
#endif

//	=================== ROMC[W ========================

int storeBin (	char *hex)
{
	int objlen,adrlen;
	unsigned int start,end;
	char *p;
//	printf("hex=\"%s\"\n",hex);
	p= hex; p++;
	adrlen=hextoNib((int)(*p)) +1; p++;
	objlen=toByte(p )-adrlen -1; p+=2;
//	printf("adrlen=%d objlen=%d\n",adrlen,objlen);
	for(start=0; adrlen>0; adrlen--)
	{
		start <<= 8;
		start |= toByte( p ); p+=2;
	}
	start -= Opt.O_offs;
	end = start +objlen-1;
//	printf("start=%06Xh end=%06Xh\n",start,end);
	if(start>Opt.O_size || end>=Opt.O_size)
		return 0;
	if(start < ObjBegin) ObjBegin=start;
	if(end > ObjLast) ObjLast=end;
	for(;start<=end;start++)
	{
		Obj[start]=(BYTE)toByte(p);
		p+=2;
	}
	return objlen;
}

//	=================== St@CROMC[Wɕϊ ========================

int srecToBinary(FILE *fpIn)
{
	char buff[BUFF_SIZE];
	int lineRead=0;
	while( fgets(buff,BUFF_SIZE,fpIn) )
	{
		int lenline;
		lineRead++;
		if(buff[0] !='S') continue;
		if( (lenline=strlen(buff))>(BUFF_SIZE-2) )
			pexit("Too long line %d.",lenline);
		else
		lenline--; buff[lenline]='\0';
		if( lenline< 10	 )
			pexit("Too short line %d.",lineRead);
		if( lenline != toByte(&buff[2])*2 + 4)
			pexit("Illegal line %d.",lineRead);
		if(! Opt.Ign )
		if( calcChecksum (&buff[2])!= 0xFF)
			pexit("Checksum wrong at line %d.",lineRead);

		switch(buff[1]-'0')
		{
		case 0:	// wb_R[h
			printHeader(buff );
			break;
		case 1:	// 2byteAhX
		case 2:	// 3byteAhX
		case 3:	// 4byteAhX R[h/f[^
			if(storeBin(buff)==0)
				pexit("Out of address range at line %d.",lineRead);
			break;
		case 7:	// 4byteAhX
		case 8: // 3byteAhX
		case 9: // 2byteAhX ^[~l[VR[h
			printFooter(buff);
			return 1;	// normal end;
			// break;
		default:
			pexit("Unknown record type %d.",lineRead);
			break;
		}	// end_switch
	}
	pexit("Abnormal file end %d.",lineRead);
	return 0;
}

//	=================== bZ[WfĂ΂B ========================

void pexit( char *format, ... )
{
	va_list ap;
	fprintf(stderr,"Error: ");
	va_start(ap,format);
	vfprintf(stderr, format,ap);
	va_end(ap);
	fprintf(stderr,"\n");
//	fcloseall();
	if(Obj !=NULL)free(Obj);
	exit(1);
}

void sigintExit(int x){pexit("caught Ctrl-C or killed.");}
void sigsegvExit(int x){pexit("caught SIGSEGV unexpected.");}


//	=================== ߂ ǂB ========================

int	 main( int ac, char *av[])
{
	FILE *fp;

	fprintf(stderr,"%s\n",Version);

	signal(SIGINT,sigintExit);
	signal(SIGTERM,sigintExit);
	signal(SIGSEGV,sigsegvExit);

	getArgOption(ac,av);

	if((Obj=(BYTE*)malloc(Opt.O_size))==NULL)
		pexit("Insufficient memory.");
	memset(Obj,0xFF,Opt.O_size);
	ObjBegin=Opt.O_size;
	ObjLast=0;

	if(Opt.Src==NULL) fp=stdin;
	else if ((fp = fopen(Opt.Src,"rt")) == NULL)	// ̓t@C
		pexit("Input file[%s] open failed.",Opt.Src );

	srecToBinary(fp);
	fclose(fp);

	if(Opt.Dest==NULL)fp=stdout;
	else if ((fp = fopen(Opt.Dest,"wb")) == NULL)	// o̓t@C
		pexit("Input file[%s] open failed.",Opt.Dest );

	ObjDump(fp);
	return 0;
}
